export function $classOf(arg: any): any;
export function $isString(arg: any): arg is string;
export function $isNumber(arg: any): arg is number;
export function $isObject(arg: any): arg is Record<string, any>;
export const $isArray: (arg: any) => arg is any[];
export function $in(key: any, ref: any): boolean;
export function $eq(x: any, y: any): boolean;
export const $: {
    <T extends keyof HTMLElementTagNameMap>(config: $Config & {
        e: T;
    }): HTMLElementTagNameMap[T];
    <E extends HTMLElement>(config: $Config & {
        e: E;
    }): E;
    (config: $Config): HTMLElement;
};
export const $svg: {
    <T extends keyof SVGElementTagNameMap>(config: $SVGConfig & {
        e: T;
    }): SVGElementTagNameMap[T];
    <E extends SVGElement>(config: $SVGConfig & {
        e: E;
    }): E;
    (config: $SVGConfig): SVGElement;
};
export const $$: {
    <T extends keyof HTMLElementTagNameMap>(e: T, a?: $Attributes, p?: $Properties, ...i: $Item[]): HTMLElementTagNameMap[T];
    <E extends HTMLElement>(e: E, a?: $Attributes, p?: $Properties, ...i: $Item[]): E;
};
export function $css(style: $CSS, splitter?: string): string;
export function $highlight(pattern: RegExp, highlighters: ((chunk: string, index: number) => $Item)[], innerText: string): $Item[];
export function $locale(locales: Record<string, Record<string, string | Record<string, string>>>, defaultLanguage: string, languages?: readonly string[]): (text?: string | undefined, version?: string | undefined) => string;
export type $Attributes = Record<string, string | number | boolean>;
export type $Properties = Record<string, any>;
export type $Item = HTMLElement | Text | SVGElement | string | number | $Config;
export type $SVGItem = SVGElement | Text | string | number | $SVGConfig;
export type $Config = {
    e: keyof HTMLElementTagNameMap | HTMLElement;
    a?: $Attributes;
    p?: $Properties;
    i?: $Item[];
};
export type $SVGConfig = {
    e: keyof SVGElementTagNameMap | SVGElement;
    a?: $Attributes;
    p?: $Properties;
    i?: $SVGItem[];
};
export type $CSSRules = {
    [attributeOrSelector: string]: string | number | $CSSRules;
};
export type $CSS = {
    [selector: string]: $CSSRules;
};
